<template>
  <div class="p-sm-2">
    <div class="my-3 pb-2">
      <div class="d-flex justify-content-between align-items-center">
        <div class="d-flex justify-content-start align-items-center">
          <img
            style="height: auto; width: 12vw; max-width: 100px"
            class="me-2 me-sm-3"
            src="@/assets/icon-app-bitcoin.svg"
          />
          <div>
            <svg
              width="8"
              height="8"
              viewBox="0 0 8 8"
              fill="none"
              xmlns="http://www.w3.org/2000/svg"
            >
              <circle cx="4" cy="4" r="4" fill="#00CD98" />
            </svg>
            <small class="ms-1 text-success">Running</small>
            <h3 class="d-block font-weight-bold mb-1">Bitcoin</h3>
            <span v-if="knotsVersion" class="d-block text-muted"
              >Bitcoin Knots {{ knotsVersion }} (Based on Bitcoin Core
              {{ coreVersion }})</span
            >
            <span v-else class="d-block text-muted"
              >Bitcoin Core {{ coreVersion }}</span
            >
          </div>
        </div>
        <div>
          <b-dropdown
            variant="link"
            toggle-class="text-decoration-none p-0"
            no-caret
            right
          >
            <template #button-content>
              <svg
                width="18"
                height="4"
                viewBox="0 0 18 4"
                fill="none"
                xmlns="http://www.w3.org/2000/svg"
              >
                <path
                  fill-rule="evenodd"
                  clip-rule="evenodd"
                  d="M2 4C3.10457 4 4 3.10457 4 2C4 0.89543 3.10457 0 2 0C0.89543 0 0 0.89543 0 2C0 3.10457 0.89543 4 2 4Z"
                  fill="#6c757d"
                />
                <path
                  fill-rule="evenodd"
                  clip-rule="evenodd"
                  d="M9 4C10.1046 4 11 3.10457 11 2C11 0.89543 10.1046 0 9 0C7.89543 0 7 0.89543 7 2C7 3.10457 7.89543 4 9 4Z"
                  fill="#6c757d"
                />
                <path
                  fill-rule="evenodd"
                  clip-rule="evenodd"
                  d="M16 4C17.1046 4 18 3.10457 18 2C18 0.89543 17.1046 0 16 0C14.8954 0 14 0.89543 14 2C14 3.10457 14.8954 4 16 4Z"
                  fill="#6c757d"
                />
              </svg>
            </template>
            <b-dropdown-item href="#" @click.prevent="showSwitchModal = true">{{
              isKnots ? "Switch to Bitcoin Core" : "Switch to Bitcoin Knots"
            }}</b-dropdown-item>
            <!-- <b-dropdown-divider /> -->
            <!-- <b-dropdown-item variant="danger" href="#" disabled>Stop LND</b-dropdown-item> -->
          </b-dropdown>
        </div>
      </div>
    </div>

    <b-modal v-model="showSwitchModal" centered hide-footer>
      <template #header>
        <div class="px-2 px-sm-3 pt-2 d-flex justify-content-between w-100">
          <h3>Are you sure?</h3>
          <!-- Emulate built in modal header close button action -->
          <a
            href="#"
            class="align-self-center"
            @click.stop.prevent="showSwitchModal = false"
          >
            <svg
              width="18"
              height="18"
              viewBox="0 0 18 18"
              fill="none"
              xmlns="http://www.w3.org/2000/svg"
            >
              <path
                fill-rule="evenodd"
                clip-rule="evenodd"
                d="M13.6003 4.44197C13.3562 4.19789 12.9605 4.19789 12.7164 4.44197L9.02116 8.1372L5.32596 4.442C5.08188 4.19792 4.68615 4.19792 4.44207 4.442C4.198 4.68607 4.198 5.0818 4.44207 5.32588L8.13728 9.02109L4.44185 12.7165C4.19777 12.9606 4.19777 13.3563 4.44185 13.6004C4.68592 13.8445 5.08165 13.8445 5.32573 13.6004L9.02116 9.90497L12.7166 13.6004C12.9607 13.8445 13.3564 13.8445 13.6005 13.6004C13.8446 13.3563 13.8446 12.9606 13.6005 12.7165L9.90505 9.02109L13.6003 5.32585C13.8444 5.08178 13.8444 4.68605 13.6003 4.44197Z"
                fill="#6c757d"
              />
            </svg>
          </a>
        </div>
      </template>
      <div class="px-4 pb-2">
        <p v-if="isKnots">
          Bitcoin Knots provides all features of Bitcoin Core, but is more
          reliable and faster. There are no known advantages to using Bitcoin
          Core over Bitcoin Knots on Citadel. The version of Bitcoin Knots
          Citadel uses has the same default settings as Bitcoin Core. Enabling
          Bitcoin Core will take a few minutes to switch over. During that time,
          certain apps may not work as expected. Are you sure you want to switch
          to Bitcoin Core?
        </p>
        <p v-else>
          Enabling Bitcoin Knots will take a few minutes to switch over. During
          that time, certain apps may not work as expected. Are you sure you
          want to switch to Bitcoin Knots?
        </p>
        <div class="d-flex flex-row gap-3">
          <b-button variant="success" @click="changeImpl"
            >Yes, I am sure</b-button
          >
          <b-button variant="danger" @click="showSwitchModal = false"
            >No, cancel</b-button
          >
        </div>
      </div>
    </b-modal>
    <b-row class="row-eq-height">
      <b-col col cols="12" md="6" xl="4">
        <bitcoin-wallet></bitcoin-wallet>
      </b-col>
      <b-col col cols="12" md="6" xl="4">
        <card-widget
          header="Blockchain"
          :loading="
            bitcoinStore.percent !== 100 || bitcoinStore.blocks.length === 0
          "
        >
          <div class>
            <div class="px-3 px-lg-4 mb-3">
              <div class="w-100 d-flex justify-content-between mb-2">
                <span class="align-self-end">Synchronized</span>
                <h3 class="font-weight-normal mb-0">
                  <span v-if="bitcoinStore.percent !== -1">
                    {{
                      bitcoinStore.percent >= 99.99
                        ? 100
                        : round(bitcoinStore.percent)
                    }}
                    <small class>%</small>
                  </span>

                  <span
                    v-else
                    class="loading-placeholder loading-placeholder-lg d-block"
                    style="width: 6rem"
                  ></span>
                </h3>
              </div>
              <b-progress
                :value="Math.round(bitcoinStore.percent)"
                class="mb-1"
                variant="success"
                :style="{ height: '4px' }"
                animated
                striped
              ></b-progress>
              <small
                v-if="bitcoinStore.currentBlock < bitcoinStore.blockHeight - 1"
                class="text-muted d-block text-end"
              >
                {{ bitcoinStore.currentBlock.toLocaleString() }} of
                {{ bitcoinStore.blockHeight.toLocaleString() }} blocks
                <b-icon-info-circle-fill
                  v-tooltip.bottom="t('bitcoin.sync-info')"
                  icon="info-circle-fill"
                  style="opacity: 0.4"
                  variant="dark"
                  class="ms-1"
                />
              </small>
            </div>
            <p class="px-3 px-lg-4 mb-3">Latest Blocks</p>
            <blockchain :num-blocks="3"></blockchain>
            <div class="px-3 px-lg-4 py-2"></div>
          </div>
        </card-widget>
      </b-col>
      <b-col col cols="12" xl="4">
        <card-widget header="Network">
          <div class>
            <div class="px-3 px-lg-4 pb-2">
              <b-row>
                <b-col col cols="6" md="3" xl="6">
                  <stat
                    title="Connections"
                    :value="bitcoinStore.stats.peers"
                    suffix="Peers"
                    show-numeric-change
                  ></stat>
                </b-col>
                <b-col col cols="6" md="3" xl="6">
                  <stat
                    title="Mempool"
                    :value="abbreviateSize(bitcoinStore.stats.mempool)[0]"
                    :suffix="abbreviateSize(bitcoinStore.stats.mempool)[1]"
                    show-percent-change
                  ></stat>
                </b-col>
                <b-col col cols="6" md="3" xl="6">
                  <stat
                    title="Hashrate"
                    :value="abbreviateHashRate(bitcoinStore.stats.hashrate)[0]"
                    :suffix="abbreviateHashRate(bitcoinStore.stats.hashrate)[1]"
                    show-percent-change
                  ></stat>
                </b-col>
                <b-col col cols="6" md="3" xl="6">
                  <stat
                    title="Blockchain Size"
                    :value="
                      abbreviateSize(bitcoinStore.stats.blockchainSize)[0]
                    "
                    :suffix="
                      abbreviateSize(bitcoinStore.stats.blockchainSize)[1]
                    "
                    show-percent-change
                  ></stat>
                </b-col>
              </b-row>
            </div>
          </div>
        </card-widget>
      </b-col>
    </b-row>
  </div>
</template>

<script lang="ts" setup>
import { ref, computed, onMounted, onBeforeUnmount } from "vue";
import { useI18n } from "vue-i18n";
import { BIconInfoCircleFill } from "bootstrap-icons-vue";
import CardWidget from "@/components/CardWidget.vue";
import Blockchain from "@/components/Blockchain.vue";
import Stat from "@/components/Utility/Stat.vue";
import BitcoinWallet from "@/components/BitcoinWallet.vue";
import useBitcoinStore from "@/store/bitcoin";

const { t } = useI18n();
const bitcoinStore = useBitcoinStore();

const interval = ref<null | number>(null);

const showSwitchModal = ref(false);

const coreVersion = computed(() => {
  return bitcoinStore.version.split("/")[1]?.split(":")[1];
});
const knotsVersion = computed(() => {
  return bitcoinStore.version.split("/")[2]?.split(":")[1];
});
const isKnots = ref(false);
onMounted(async () => {
  fetchStats();
  await bitcoinStore.getVersion();
  isKnots.value = knotsVersion.value !== undefined;
  interval.value = window.setInterval(fetchStats, 5000);
});

async function changeImpl() {
  showSwitchModal.value = false;
  await useCitadel().bitcoin.setImpl(isKnots.value ? "core" : "knots");
  window.location.reload();
}

onBeforeUnmount(() => {
  window.clearInterval(interval.value!);
});
function abbreviateHashRate(n: number): [number, string] {
  if (n < 1e3) return [Number(n.toFixed(1)), "H/s"];
  if (n >= 1e3 && n < 1e6) return [Number((n / 1e3).toFixed(1)), "kH/s"];
  if (n >= 1e6 && n < 1e9) return [Number((n / 1e6).toFixed(1)), "MH/s"];
  if (n >= 1e9 && n < 1e12) return [Number((n / 1e9).toFixed(1)), "GH/s"];
  if (n >= 1e12 && n < 1e15) return [Number((n / 1e12).toFixed(1)), "TH/s"];
  if (n >= 1e15 && n < 1e18) return [Number((n / 1e15).toFixed(1)), "PH/s"];
  if (n >= 1e18 && n < 1e21) return [Number((n / 1e18).toFixed(1)), "EH/s"];
  if (n >= 1e21) return [Number(+(n / 1e21).toFixed(1)), "ZH/s"];
  // Just a fallback to prevent TS errors
  return [Number(n.toFixed(1)), "H/s"];
}
function abbreviateSize(n: number): [number, string] {
  if (n < 1e3) return [Number(n.toFixed(1)), "Bytes"];
  if (n >= 1e3 && n < 1e6) return [Number((n / 1e3).toFixed(1)), "KB"];
  if (n >= 1e6 && n < 1e9) return [Number((n / 1e6).toFixed(1)), "MB"];
  if (n >= 1e9 && n < 1e12) return [Number((n / 1e9).toFixed(1)), "GB"];
  if (n >= 1e12 && n < 1e15) return [Number((n / 1e12).toFixed(1)), "TB"];
  if (n >= 1e15) return [Number(+(n / 1e15).toFixed(1)), "PB"];
  // Just a fallback to prevent TS errors
  return [Number(n.toFixed(1)), "Bytes"];
}
function fetchStats() {
  bitcoinStore.getStats();
  bitcoinStore.getVersion();
}

definePageMeta({
  layout: "authenticated",
  pageTransition: { name: "change-page", mode: "out-in" },
});

function round(n: number) {
  return Math.round(n * 100) / 100;
}
</script>
